/*
 * a.11.c
 *
 * Example 11 from the openMP specification page.55-56
 */

#include <stdlib.h>

#ifdef _OPENMP
#include <libgomp.h>
#endif 

void do_by_16( int a, int b, float c )
{
	return;
};

int main(int argc, char **argv)
{
	int iam, npoints, x;
	float ipoints;
#ifndef _OPENMP
	abort();
#endif 
#ifdef _OPENMP
	omp_set_dynamic(0);
	omp_set_num_threads(16);
	#pragma omp parallel shared(x, npoints) private(iam, ipoints)
	{
		if (omp_get_num_threads() != 16)
			abort();
		iam = omp_get_thread_num();
		ipoints = npoints/16;
		do_by_16(x, iam, ipoints);
	}
#endif 
	return 0;
}

