/*
 * a.13.c
 *
 * Example 13 from the openMP specification page.57
 */

#ifdef _OPENMP
#include <libgomp.h>
#endif 

#define NUMBER_OF_THREADS 4

int main(int argc, char **argv)
{
	int iam;
	int sync[NUMBER_OF_THREADS];
	float work[NUMBER_OF_THREADS];
	#pragma omp parallel private(iam,neighbor) shared(work,sync)
	{
		int neighbor = 0;

#ifdef _OPENMP
		iam = omp_get_thread_num();
#endif 
		sync[iam] = 0;
		#pragma omp barrier
		
		/*Do computation into my portion of work array */
		/* work[iam] = ...; */

		/*  Announce that I am done with my work    
		 *  The first flush ensures that my
		 *   work is made visible before sync.
		 *  The second flush ensures that sync 
		 *  is made visible.    */

		#pragma omp flush(work)
		sync[iam] = 1;

		#pragma omp flush(sync)
		/*Wait for neighbor*/
#ifdef _OPENMP
		neighbor = (iam>0 ? iam : omp_get_num_threads()) - 1;
#endif
		while (sync[neighbor]==0) {
			#pragma omp flush(sync)
		}
		
		/*Read neighbor's values of work array */
			
		/*... = work[neighbor]; */
	}
	return 0;
}

