/*
 * a.16.c
 *
 * Example 16 from the openMP specification page.60
 */

#include <stdio.h>
#ifdef _OPENMP
#include <libgomp.h>
#endif 

void work( int i )
{
};

void skip( int i )
{
};

int main(int argc, char **argv)
{
#ifdef _OPENMP
	omp_lock_t lck;
#endif 
	int id = 0;

#ifdef _OPENMP
	omp_init_lock(&lck);
#endif 
	#pragma omp parallel shared(lck) private(id)
	{
#ifdef _OPENMP
		id = omp_get_thread_num();
#endif 

#ifdef _OPENMP
		omp_set_lock(&lck);
#endif 

		printf("My thread id is %d.\n", id);
		/* only one thread at a time can execute this printf */

#ifdef _OPENMP
		omp_unset_lock(&lck);
#endif 

#ifdef _OPENMP
		while (! omp_test_lock(&lck))
		{
			skip(id);	/* we do not yet have the lock,
					   so we must do something else */
		}
#endif 
		
		work(id);	/* we now have the lock and can do the work */
#ifdef _OPENMP
		omp_unset_lock(&lck);
#endif 
	}
#ifdef _OPENMP
	omp_destroy_lock(&lck);
#endif 
	return 0;
}

