/*
 * a.17.c
 *
 * Example 17 from the openMP specification page.61
 */

#ifdef _OPENMP
#include <libgomp.h>
#endif 

#ifdef _OPENMP
typedef struct { int a,b; omp_nest_lock_t lck; } pair;
#else
typedef struct { int a,b; } pair;
#endif 

int work1( )
{
	return 0;
};

int work2( )
{
	return 0;
};

int work3( )
{
	return 0;
};


void incr_a(pair *p, int a)
{
	/* Called only from incr_pair, no need to lock. */
	p->a += a;
}

void incr_b(pair *p, int b)
{
	/* Called both from incr_pair and elsewhere,
	   so need a nestable lock. */

#ifdef _OPENMP
	omp_set_nest_lock(&p->lck);
#endif 
	p->b += b;
#ifdef _OPENMP
	omp_unset_nest_lock(&p->lck);
#endif 
}

void incr_pair(pair *p, int a, int b)
{
#ifdef _OPENMP
	omp_set_nest_lock(&p->lck);
#endif 
	incr_a(p , a);
	incr_b(p, b);
#ifdef _OPENMP
	omp_unset_nest_lock(&p->lck);
#endif 
}

void f(pair *p)
{
	extern int work1(), work2(), work3();

	#pragma omp parallel sections
	{
		#pragma omp section
		incr_pair(p, work1(), work2());     
		
		#pragma omp section
		incr_b(p, work3());
	}
}

int main(int argc, char **argv)
{
	return 0;
}

