/*
 * a.22.c
 *
 * Example 22 from the openMP specification page.68
 */

#ifdef _OPENMP
#include <libgomp.h>
#endif 

int x, y, z[1000];

#pragma omp threadprivate(x)

void fun(int a)
{
	const int c = 1;
	int i = 0;

	#pragma omp parallel default(none) private(a) shared(z)
	{
		int j = 1;
#ifdef _OPENMP
		j = omp_get_num_threads();
#endif 
			/* O.K.  - j is declared within parallel region */
		a = z[j];	/* O.K.  - a is listed in private clause
				       - z is listed in shared clause */
		x = c;		/* O.K.  - x is threadprivate
				       - c has const-qualified type */
		z[i] = y;	/* Error - cannot reference i or y here */

		#pragma omp for firstprivate(y)
		for (i=0; i<10 ; i++)
		{
			z[i] = y;	/* O.K. - i is the loop control variable
					       - y is listed in firstprivate clause */
		}
		z[i] = y;	/* Error - c annot reference i or y here */
	}
}

int main(int argc, char **argv)
{
	return 0;
}

