/*
 * a.25.c
 *
 * Example 25 from the openMP specification page.71-73
 */

#include <stdlib.h>

#ifdef _OPENMP
#include <libgomp.h>
#endif 


void get_values(float a, float b, float x, float y) 
{
}

void get_float(float *f) 
{
}

void use_values(float a, float b, float x, float y) 
{
}

float x, y;
#pragma omp threadprivate(x, y)

void init( )
{
	float a;
	float b;

	#pragma omp single copyprivate(a,b,x,y)
	{
		get_values(a,b,x,y);  
	}
	use_values(a, b, x, y);
}

float read_next( )
{
	float * tmp;
	float return_val;

	#pragma omp single copyprivate(tmp)
	{
		tmp = (float *) malloc(sizeof(float));
	}

	#pragma omp master
	{
		get_float( tmp );
	}

	#pragma omp barrier
		return_val = *tmp;

	#pragma omp barrier

	#pragma omp single
	{
		free(tmp);
	}

	return return_val;
}

#ifdef _OPENMP
omp_lock_t *new_lock()
{
	omp_lock_t *lock_ptr;

	#pragma omp single copyprivate(lock_ptr)
	{
		lock_ptr = (omp_lock_t *) malloc(sizeof(omp_lock_t));
		omp_init_lock( lock_ptr );
	}

	return lock_ptr;
}
#endif

int main(int argc, char **argv)
{
	return 0;
}

